<template>
  <nav class="flex align-items-center text-center" v-bind:class="themeClasses">
    <div class="container m-container-no-gutter">
      <div class="flex justify-content-between flex-vertical-center">
        <div class="nav-left flex flex-1 align-items-center">
          <!-- <button
            @click="openNavMenu()"
            v-bind:class="themeClasses"
            class="nav-menu-toggle-button"
            v-if="isMobile"
          >
            Nav Menu
          </button> -->
          <div class="d-md-none">
            <a v-if="!fromApp" class="d-flex" href="/"
              ><i class="ic-home" :class="themeClasses"></i
            ></a>
            <div
              class="check-branch"
              v-if="fromApp"
              @click="() => $emit('check-branch-click')"
            >
              {{ $t("branchSelector.button.checkBranch") }}
            </div>
          </div>
        </div>

        <div class="logo-column" v-if="!fromApp">
          <router-link class="logo text-center text-md-left" to="/"
            ><logo
          /></router-link>
        </div>

        <div v-if="group && groupId && !isMobile" v-show="false">
          <nav-branch-selector />
        </div>

        <div
          v-if="displayAccountInfo"
          class="nav-right flex align-items-center justify-content-end flex-1"
        >
          <a
            v-if="!isLogin"
            @click.prevent.stop="startLogin"
            v-bind:href="loginUri"
            class="login-button"
          >
            {{ $t(`nav.login.${isMobile ? "mobileButton" : "desktopButton"}`) }}
          </a>
          <a
            ref="accountMenuButton"
            href="#"
            @click.prevent.stop="toggleAccountMenu(accountMenuPosition)"
            :class="[themeClasses, `member-${account.realLevel}`]"
            v-if="isLogin"
            class="account"
          >
            <span class="account-detail">
              <span class="account-level">{{ account.levelTitle }}</span>
              <span class="account-name">{{ account.name }}</span>
            </span>
          </a>
          <div class="locale-selector-container">
            <input class="d-none" type="checkbox" id="locale-menu-toggle" />
            <label class="locale-selector" for="locale-menu-toggle">
              {{ $t(`nav.languages.${locale}`) }} <i class="ic-sm-arrow"></i>
              <div class="locale-menu" v-bind:class="themeClasses">
                <a
                  @click="locale = l"
                  class="locale-menu-item"
                  v-for="(l, index) in locales"
                  :key="index"
                  >{{ $t(`nav.languages.${l}`) }}</a
                >
              </div>
            </label>
          </div>
        </div>
      </div>
    </div>
  </nav>
</template>
<script>
import Logo from "./Logo";
import { changeLocale } from "@/i18n";
import NavBranchSelector from "./NavBranchSelector";
import { mapGetters, mapState, mapActions } from "vuex";

export default {
  data() {
    return {
      locales: ["zh-TW", "en-US"]
    };
  },
  components: {
    Logo,
    NavBranchSelector
  },
  methods: {
    ...mapActions(["openNavMenu"]),
    ...mapActions("account", ["startLogin", "logout", "toggleAccountMenu"]),
    goBack() {
      this.$router.back();
    }
  },
  computed: {
    ...mapGetters("theme", ["themeClasses"]),
    ...mapGetters("account", ["isLogin"]),
    ...mapState("account", ["loginUri", "account"]),
    ...mapState("group", ["group"]),
    ...mapState(["isMobile"]),
    accountMenuPosition() {
      const rect = this.$refs.accountMenuButton.getBoundingClientRect();
      return {
        top: rect.bottom + 18,
        left: rect.left + rect.width / 2 - 6
      };
    },
    locale: {
      get() {
        return this.$store.state.locale;
      },
      set(val) {
        changeLocale(val);

        this.$store.commit("setLocale", val);
      }
    },
    groupId() {
      return this.$route.params.groupId;
    },
    fromApp() {
      return this.account && this.account.fromApp;
    },
    displayAccountInfo() {
      return !this.fromApp || this.$route.name !== "ReservationRecords";
    }
  }
};
</script>
<style lang="scss" scoped>
nav {
  position: relative;
  border-bottom: 1px $color-silver-grey dashed;
  z-index: 3;
  height: 48px;
  background-color: $color-white;
  color: $color-secondary-black;
  @include media-breakpoint-up(md) {
    height: 68px;
  }

  &.theme-vip-member {
    color: $color-skm-gold;
    background-color: $color-vip-black;
    box-shadow: inset 0 -1px 0 0 $color-gold-300;
    border: none;

    a {
      color: inherit;
    }

    .check-branch {
      color: $color-skm-gold;
    }
  }

  &.theme-map-member,
  &.theme-general-member {
    color: $color-skm-red;
  }
}

.check-branch {
  cursor: pointer;
  color: $color-skm-red;
  font-weight: bold;
  font-size: 14px;
}

.flex-vertical-center {
  align-items: center;
}

.logo-column {
  justify-content: center;
  flex: 0 0 180px;

  @include media-breakpoint-up(sm) {
    flex: 0 0 212px;
  }

  @include media-breakpoint-up(md) {
    justify-content: flex-start;
  }
}

.logo {
  display: inline-block;
  width: 100%;
  text-align: left;

  @include media-breakpoint-up(md) {
    order: 1;
  }
}

.nav-left {
  @include media-breakpoint-up(md) {
    order: 2;
  }
}

.nav-right {
  @include media-breakpoint-up(md) {
    order: 3;
  }
}

.locale-selector-container {
  display: none;
  margin-left: 40px;
  vertical-align: middle;

  @include media-breakpoint-up(md) {
    display: inline-block;
  }
}

.locale-selector {
  display: inline-block;
  position: relative;
  font-size: 14px;
  margin: 0;
  padding-right: 1.25em;
  margin-right: $grid-gutter-width/2;

  .ic-sm-arrow {
    font-size: 0.5em;
    position: absolute;
    top: 50%;
    right: 0;
    transform: translate(0, -50%);
  }
}

.locale-menu {
  pointer-events: none;
  opacity: 0;
  position: absolute;
  color: $color-white;
  background-color: $color-dark-red;
  top: 100%;
  padding: 0.5em 0;
  left: 50%;
  transform: translate(-55%, -10%);
  transition: opacity 0.2s, transform 0.3s;

  &:before {
    content: "";
    display: block;
    border-width: 5px;
    border-style: solid;
    border-color: transparent transparent $color-dark-red transparent;
    position: absolute;
    top: 0;
    left: 50%;
    transform: translate(-50%, -100%);
  }

  &-mb {
    color: $color-primary-grey;
    a {
      user-select: none;
      cursor: pointer;
      display: inline-block;
      font-size: 13px;
      border: 2px transparent solid;
      border-radius: 4px;
      padding: 1px 0;
      width: 24px;
      margin-right: 4px;
      text-align: center;
      transition: border-color ease 0.4s, color ease 0.4s;

      &.is-active {
        border-color: $color-skm-red;
        color: $color-skm-red;
      }
    }
  }
  &.theme-vip-member {
    background-color: $color-skm-gold;

    &:before {
      border-color: transparent transparent $color-skm-gold transparent;
    }
  }
}

.locale-menu-item {
  display: block;
  padding: 0.5em 0.75em;
}

#locale-menu-toggle:checked + .locale-selector {
  .locale-menu {
    opacity: 1;
    transform: translate(-55%, 15%);
    pointer-events: auto;
  }
}

.login-button,
.account {
  color: inherit;
  font-size: 14px;
  cursor: pointer;
  user-select: none;
}

.account {
  // color: $color-skm-red;
  // margin-right: 22px;

  .account-detail {
    display: none;
    margin-left: 9px;
  }

  .account-level {
    color: $color-secondary-black;
  }

  .account-name {
    font-weight: bold;
    vertical-align: middle;
    color: $color-secondary-black;
  }

  &:before {
    content: "";
    display: inline-block;
    width: 22px;
    height: 22px;
    vertical-align: middle;
    // background: url("/static/images/ic-member-general.svg");
  }

  @include media-breakpoint-up(md) {
    margin-right: 0;

    .account-detail {
      display: inline-block;
    }
  }

  // &.theme-vip-member {
  //   color: $color-skm-gold !important;

  //   &:before {
  //     background: url("/static/images/ic-member-vip.svg") !important;
  //   }
  // }

  // &.theme-map-member {
  //   color: $color-secondary-black;

  //   &:before {
  //     background: url("/static/images/ic-member-map.svg");
  //   }
  // }

  &.member-0 {
    .account-level {
      color: $color-secondary-black;
    }
    &::before {
      background: url("/static/images/ic-member-map.svg");
    }
  }

  &.member-S,
  &.member-N {
    .account-level {
      color: $color-skm-red;
    }
    &::before {
      background: url("/static/images/ic-member-general.svg");
    }
  }

  &.member-V {
    .account-level {
      color: $color-skm-gold !important;
    }
    &:before {
      background: url("/static/images/ic-member-vip.svg") !important;
    }
  }
}

.nav-menu-toggle-button {
  display: inline-block;
  width: 48px;
  height: 48px;
  border: none;
  padding: 0;
  margin: 0;
  background-color: transparent;
  background-image: url("/static/images/ic-hamburger-general.svg");
  background-size: 20px 20px;
  background-repeat: no-repeat;
  background-position: center center;
  overflow: hidden;
  text-indent: -99999px;

  &.theme-vip-member {
    background-image: url("/static/images/ic-hamburger-vip.svg");
  }
}

.fa-angle-left {
  font-size: 28px;
}

.ic-home {
  &:before {
    content: "";
    display: inline-block;
    width: 22px;
    height: 22px;
    vertical-align: middle;
    background: url("/static/images/ic-home-red.svg") center/contain no-repeat;
  }

  &.theme-vip-member {
    &:before {
      background: url("/static/images/ic-home-vip.svg") center/contain no-repeat;
    }
  }
}

.account-level {
  vertical-align: middle;
}
</style>
